﻿//using System.Text;
using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Xml.Serialization;

namespace HSPI_MQTT
{
    [Serializable]
    [XmlRoot("Settings")]
    public class Settings
    {
        //public Settings() { Mappings = new MappingList(); }
        
        [XmlElement("MQTTServer")]
        public String MQTTServer { get; set; }

        [XmlElement("MQTTClientId")]
        public String MQTTClientId { get; set; }

        [XmlElement("HomeSeerTopic")]
        public String HomeSeerTopic { get; set; }
        public MappingList Mappings { get; internal set; }

        //[XmlElement("Mappings")]
        //public MappingList Mappings { get; set; }

        [XmlElement("Mapping")]
        public List<Mapping> mappingList = new List<Mapping>(); 
        
    }
            
    public class MappingList
    {
        public MappingList() 
        {
            Items = new List<Mapping>();
        }

        [XmlElement("Mapping")]
        public List<Mapping> Items {get;set;}        
    }
    
    public class Mapping
    {           
        public Mapping() { Topics = new TopicsList(); }        

        [XmlElement("DeviceId")]
        public String DeviceId { get; set; }

        //[XmlElement("DeviceReference")]
        internal Int32 DeviceReference { get; set; }

        //[XmlElement("DeviceName")]
        internal String DeviceName { get; set; }
        
        //[XmlElement("Topic")]
        //public Topic Topic 
        //{ 
        //    get { return _topic; }
        //    set { _topic = value; }
        //}        

        [XmlElement("Topics")]
        public TopicsList Topics { get; set; }

        [XmlElement("Format")]
        public String Format { get; set; }
    }

    // <Mapping>
    //    <DeviceId>5743857439573495</DeviceId>
    //    <Topics>
    //       <Topic Subscribe="true" DataType="json">homeseer/subtest</Topic>
    //       <Topic Publish="true" DataType="num" Scale="1" Format="#.##">homeseer/pubtest/value</Topic>
    //       <Topic Publish="true" DataType="text">homeseer/pubtest/string</Topic>    
    //    </Topics>
    // </Mapping>

    public class TopicsList
    {
        public TopicsList()
        {
            Items = new List<Topic>();
        }

        [XmlElement("Topic")]
        public List<Topic> Items { get; set; }
    }


    public class Topic
    {
        private bool _publish = false;
        private bool _subscribe = false;
    
        //[XmlAttribute(DataType = "string", AttributeName = "Name")]
        [XmlText]
        public String Name { get; set; }

        [XmlAttribute(DataType = "boolean", AttributeName = "Publish")]
        public bool Publish 
        { 
            get { return _publish; }
            set { _publish = value; }
        }        

        [XmlAttribute(DataType = "boolean", AttributeName = "Subscribe")]
        public bool Subscribe
        {
            get { return _subscribe; }
            set { _subscribe = value; }
        }
    }

    
    //public class Mapping2
    //{                
    //    private string m_deviceId;
    //    private int m_deviceRef;
    //    private string m_deviceName;
    //    private string m_topicName;
        
    //    [XmlElement("DeviceId")]
    //    public string DeviceId
    //    {
    //        get { return m_deviceId; }
    //        set { m_deviceId = value; }
    //    }

    //    [XmlElement("DeviceReference")]
    //    public int DeviceReference
    //    {
    //        get { return m_deviceRef; }
    //        set { m_deviceRef = value; }
    //    }

    //    [XmlElement("DeviceName")]
    //    public string DeviceName
    //    {
    //        get { return m_deviceName; }
    //        set { m_deviceName = value; }
    //    }

    //    [XmlElement("TopicName")]
    //    public string TopicName
    //    {
    //        get { return m_topicName; }
    //        set { m_topicName = value; }
    //    }

    //    public string BuildUnitPage()
    //    {
    //        StringBuilder p = new StringBuilder();
    //        string classname = ""; // ((m_iUnitNumber % 2) == 0 ? "tableroweven" : "tablerowodd");

    //        p.Append("<tr>\n");

    //        p.Append("<td noWrap class=\"" + classname + "\" align=center valign=middle>" + this.DeviceId + "</td>\n");
    //        //p.Append("<td noWrap class=\"" + classname + "\" align=center valign=middle>" + this.DeviceName + "</td>\n");

    //        p.Append(string.Format("<td noWrap class=\"{0}\" align=center valign=middle><a href=\"deva{2}&edit=1\">{1}</a></td>\n", classname, this.DeviceName, this.DeviceReference));

    //        p.Append("<td noWrap class=\"" + classname + "\" align=left valign=middle width='50%%'>\n");
    //        p.Append("<table border='0' width='100%' cellspacing='0' cellpadding='0'><tr>");
    //        //p.Append("<td width='15%' align=right>" + GetStringHTML(Name) + "</td>\n<td width='85%'>");
    //        p.Append("<td width='15%' align=right>" + this.TopicName + "</td>\n<td width='85%'>");
    //        p.Append("</td>");
    //        p.Append("</tr>");
    //        p.Append("</table>");
    //        p.Append("</td>");

    //        return p.ToString();
    //    }
        
    //}     
    
    //public string BuildUnitPage()
    //    {
    //        StringBuilder p = new StringBuilder();
    //        string classname = ((m_iUnitNumber % 2) == 0 ? "tableroweven" : "tablerowodd");

    //        p.Append("<tr>\n");

    //        p.Append("<td noWrap class=\"" + classname + "\" align=center valign=middle>" + m_iUnitNumber + "</td>\n");
    //        p.Append("<td noWrap class=\"" + classname + "\" align=left valign=middle width='50%%'>\n");
    //        p.Append("<table border='0' width='100%' cellspacing='0' cellpadding='0'><tr>");
    //        p.Append("<td width='15%' align=right>" + GetStringHTML(Name) + "</td>\n<td width='85%'>");
    //        p.Append("</td>");
    //        p.Append("</tr>");
    //        p.Append("</table>");
    //        p.Append("</td>");

    //        // Comm port drop down list

    //        p.Append("<td class=\"" + classname + "\" align=center>\n");
    //        p.Append("<table cellSpacing=1 cellPadding=1 border=0>\n");
    //        p.Append("<select class=\"formdropdown\" s=\"" + clsEnviracomApp.CFG_KEY_UNITPORT + m_iUnitNumber + "\" style=\"width: 100%%\" ID=\"UnitCom" + m_iUnitNumber + "\"size=\"1\">");

    //        foreach (string name in SerialPort.GetPortNames())
    //        {
    //            if ((m_sComPortName.ToLower()) == name.ToLower())
    //                p.Append(" <option value=\"" + name + "\" selected>" + name + "\n");
    //            else
    //                p.Append(" <option value=\"" + name + "\">" + name + "\n");
    //        }
    //        p.Append("</option>");
    //        p.Append("</select>\n");
    //        p.Append("</table>\n");
    //        p.Append("</td>\n");
    //        p.Append("</tr>\n");
    //        return p.ToString();
    //    }
}
